/*
$Id: SMHA_LR460_1.ddl 1.51 2007/01/14 22:16:53EST Basson, Dominique (Dominique Basson) Dev  $
$ProjectName: d:/elect/source/device_descriptions/hart/lr460/pdm/lr460_hart_pdm.pj $   $Locker:  $

*/


/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------


         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Resources ------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------
*/

MANUFACTURER 88, DEVICE_TYPE 0xD3, DEVICE_REVISION 3, DD_REVISION 5

/* Defines --------------------------------------------------------------------*/
#define DD_VERSION               "1.03.01-00"
#define FIRMWARE_REVISION        "1.03.00-00"
#define DEVICE_MANUAL_FILENAME   "lr460_user_manual_en.pdf|de|lr460_user_manual_de.pdf"
#define DEVICE_ORDER_NUMBER      "7ML542x-xxxxx"
#define DEVICE_TYPE_NAME         "Sitrans LR460"
#define DEVICE_TYPE_DESCRIPTION  "HART Echo Field Device Sitrans LR460"
#define DEVICE_TYPE_WEB_SITE     "www.siemens-milltronics.com"
#define DEVICE_TYPE_MANUFACTURER "Siemens Milltronics"


#ifdef _V602_
#define EDDL_SUPPORT
#endif

#define MAX_FLOAT          999999.0
#define MIN_FLOAT         -999999.0

#define SECONDS_PER_YEAR 31536000
#define SECONDS_PER_DAY     86400
#define SECONDS_PER_HOUR     3600

#define DEVICE_BUSY            32
#define MAX_XMTR_STATUS_LEN     4
#define STATUS_SIZE            16

#define OPT_PHYS_IDENT_NUMBER_MANUFACTURER
#define DEFAULT_MANUFACTURER_ID                  88
#define DEFAULT_VALUE_phys_device_id             "SITRANS LR460"
#define MANUFACTURER_SPECIFIC_phys_factory_reset
#define DEFAULT_phys_ident_number                1
#define NO_phys_diagnosis_extension_mask  // We have our own definition for this parameter
#define NO_phys_diagnosis_extension
#define NO_phys_hw_write_protection

/* Factory reset options */
#define PHYS_FACTORY_RESET_MNF      32768
#define PHYS_FACTORY_RESET_METAL    35000
#define PHYS_FACTORY_RESET_CONCRETE 35001
#define PHYS_FACTORY_RESET_CMD      2506
#define PHYS_FACTORY_RESET_ADDRESS  2712


/*Transducer options  */
#define  TRANSDUCER_MWAVE_NO_HORN   300
#define  TRANSDUCER_MWAVE_2IN_HORN  301
#define  TRANSDUCER_MWAVE_3IN_HORN  302
#define  TRANSDUCER_MWAVE_4IN_HORN  303


/* Unit conversion macro's */
#define CM_PER_M     ( 100.0 )
#define MM_PER_M     ( 1000.0 )
#define FT_PER_M     ( 1/0.3048 )
#define IN_PER_M     ( 1/0.0254 )
#define TO_PV_UNITS_FROM_M(value)                        \
   SELECT (trans1_sensor_unit)                   \
      {                                                      \
      CASE 44: value * FT_PER_M; \
      CASE 45: value;  \
      CASE 47: value * IN_PER_M;  \
      CASE 48: value * CM_PER_M;  \
      CASE 49: value * MM_PER_M;  \
      }
//      CASE 57: value;  \
//      CASE 251: value;  \
#define TO_FB1_OUT_UNITS_FROM_M(value)                        \
   SELECT (func1_AI_out_unit)                   \
      {                                                      \
      CASE 44: value * FT_PER_M; \
      CASE 45: value;  \
      CASE 47: value * IN_PER_M;  \
      CASE 48: value * CM_PER_M;  \
      CASE 49: value * MM_PER_M;  \
      CASE 57: value;  \
      CASE 251: value;  \
      }
#define TO_FB2_OUT_UNITS_FROM_M(value)                        \
   SELECT (func2_AI_out_unit)                   \
      {                                                      \
      CASE 44: value * FT_PER_M; \
      CASE 45: value;  \
      CASE 47: value * IN_PER_M;  \
      CASE 48: value * CM_PER_M;  \
      CASE 49: value * MM_PER_M;  \
      CASE 57: value;  \
      CASE 251: value;  \
      }

/* Min, max and defaults */
#define DEFAULT_VALUE_func1_upper_range_value      100.0
#define DEFAULT_VALUE_func1_lower_range_value        0.0
#define DEFAULT_VALUE_func1_pv_upper_range_value   100.0
#define DEFAULT_VALUE_func1_pv_lower_range_value     0.0

#define DEFAULT_VALUE_func2_upper_range_value      100.0
#define DEFAULT_VALUE_func2_lower_range_value        0.0
#define DEFAULT_VALUE_func2_pv_upper_range_value   100.0
#define DEFAULT_VALUE_func2_pv_lower_range_value     0.0

#define MAX_VALUE_func1_AI_pv_ftime                300.0
#define MIN_VALUE_func1_AI_pv_ftime                  0.0
#define DEFAULT_VALUE_func1_AI_pv_ftime             10.0

#define MAX_VALUE_func2_AI_pv_ftime                300.0
#define MIN_VALUE_func2_AI_pv_ftime                  0.0
#define DEFAULT_VALUE_func2_AI_pv_ftime             10.0

#define MAX_LIMIT 999.00
#define MIN_LIMIT -999.00
#define MAX_VALUE_func1_AI_hi_hi_lim            TO_FB1_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func1_AI_hi_hi_lim            TO_FB1_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func1_AI_hi_hi_lim        TO_FB1_OUT_UNITS_FROM_M(999.00)

#define MAX_VALUE_func1_AI_hi_lim               TO_FB1_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func1_AI_hi_lim               TO_FB1_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func1_AI_hi_lim           TO_FB1_OUT_UNITS_FROM_M(999.00)

#define MAX_VALUE_func1_AI_lo_lim               TO_FB1_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func1_AI_lo_lim               TO_FB1_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func1_AI_lo_lim           TO_FB1_OUT_UNITS_FROM_M(-999.00)

#define MAX_VALUE_func1_AI_lo_lo_lim            TO_FB1_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func1_AI_lo_lo_lim            TO_FB1_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func1_AI_lo_lo_lim        TO_FB1_OUT_UNITS_FROM_M(-999.00)

#define MAX_VALUE_func2_AI_hi_hi_lim            TO_FB2_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func2_AI_hi_hi_lim            TO_FB2_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func2_AI_hi_hi_lim        TO_FB2_OUT_UNITS_FROM_M(999.00)

#define MAX_VALUE_func2_AI_hi_lim               TO_FB2_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func2_AI_hi_lim               TO_FB2_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func2_AI_hi_lim           TO_FB2_OUT_UNITS_FROM_M(999.00)

#define MAX_VALUE_func2_AI_lo_lim               TO_FB2_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func2_AI_lo_lim               TO_FB2_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func2_AI_lo_lim           TO_FB2_OUT_UNITS_FROM_M(-999.00)

#define MAX_VALUE_func2_AI_lo_lo_lim            TO_FB2_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func2_AI_lo_lo_lim            TO_FB2_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func2_AI_lo_lo_lim        TO_FB2_OUT_UNITS_FROM_M(-999.00)

#define FUNC1_DEFAULT_UNIT                     1342
#define FUNC2_DEFAULT_UNIT                     1342

#define DEFAULT_VALUE_func1_AI_out_unit        1342
#define DEFAULT_VALUE_func2_AI_out_unit        1342

#define FUNC2_AVAILABLE

#define func1_CHANNEL_LIST  {0x10E, [SV1_label]},{ 0x110, [SV2_label]}
#define func2_CHANNEL_LIST  {0x10E, [SV1_label]},{ 0x110, [SV2_label]}

#define FUNC1_UNIT_LIST  {45,[meter],[meters_help] },{ 48,[cm],[centimeters_help]},{49,[mm],[millimeters_help]},{44,[ft],[feet_help]},{47,[in],[inches_help]}
#define FUNC2_UNIT_LIST  {45,[meter],[meters_help] },{ 48,[cm],[centimeters_help]},{49,[mm],[millimeters_help]},{44,[ft],[feet_help]},{47,[in],[inches_help]}

#define DEF_DISPLAY_FORMAT_FUNC1_AI(value)            \
   IF( (value > 999999999) || (value < -999999999) )  \
   {                                                  \
      SELECT(func1_AI_out_decimal_point)              \
      {                                               \
         CASE 0:     ".1g";                           \
         CASE 1:     ".2g";                           \
         CASE 2:     ".3g";                           \
         CASE 3:     ".4g";                           \
         CASE 4:     ".5g";                           \
         CASE 5:     ".6g";                           \
         CASE 6:     ".7g";                           \
         CASE 7:     ".8g";                           \
         DEFAULT: "8.4g" ;                            \
      }                                               \
   }                                                  \
   ELSE                                               \
   {                                                  \
      SELECT(func1_AI_out_decimal_point)              \
      {                                               \
         CASE 0:     ".0f";                           \
         CASE 1:     ".1f";                           \
         CASE 2:     ".2f";                           \
         CASE 3:     ".3f";                           \
         CASE 4:     ".4f";                           \
         CASE 5:     ".5f";                           \
         CASE 6:     ".6f";                           \
         CASE 7:     ".7f";                           \
         DEFAULT: "7.4f" ;                            \
      }                                               \
   }

#define DEF_DISPLAY_FORMAT_FUNC2_AI(value)            \
   IF( (value > 999999999) || (value < -999999999) )  \
      {                                               \
      SELECT(func2_AI_out_decimal_point)              \
         {                                            \
         CASE 0:     ".1g";                           \
         CASE 1:     ".2g";                           \
         CASE 2:     ".3g";                           \
         CASE 3:     ".4g";                           \
         CASE 4:     ".5g";                           \
         CASE 5:     ".6g";                           \
         CASE 6:     ".7g";                           \
         CASE 7:     ".8g";                           \
         DEFAULT: "8.4g" ;                            \
         }                                            \
      }                                               \
   ELSE                                               \
      {                                               \
      SELECT(func2_AI_out_decimal_point)              \
         {                                            \
         CASE 0:     ".0f";                           \
         CASE 1:     ".1f";                           \
         CASE 2:     ".2f";                           \
         CASE 3:     ".3f";                           \
         CASE 4:     ".4f";                           \
         CASE 5:     ".5f";                           \
         CASE 6:     ".6f";                           \
         CASE 7:     ".7f";                           \
         DEFAULT: "7.4f" ;                            \
         }                                            \
      }

#ifdef EDDL_SUPPORT   /* for PDM version >= 6.0 */
   #define STYLE_TABLE   STYLE TABLE;
   #define STYLE_PAGE    STYLE PAGE;
   #define STYLE_GROUP   STYLE GROUP;
   #define STYLE_DIALOG  STYLE DIALOG;
   #define STYLE_WINDOW  STYLE WINDOW;
   #define STYLE_MENU    STYLE MENU;
#else                 /* for PDM version = 5.2 */
   #define STYLE_TABLE
   #define STYLE_PAGE
   #define STYLE_GROUP
   #define STYLE_DIALOG
   #define STYLE_WINDOW
   #define STYLE_MENU
#endif

#ifdef EDDL_SUPPORT   /* for PDM version >= 6.0 */
#else                 /* for PDM version = 5.2 */
   /* YT diagram*/
   #define YT1_LABEL    [func1_AI]
   #define YT1_HELP     [func_ai_out_value_help]
   #define YT1_VALUE    func1_AI_out_value
   #define YT1_LRV      func1_AI_out_lower_range_value
   #define YT1_URV      func1_AI_out_upper_range_value
   #define YT2_LABEL    [func2_AI]
   #define YT2_HELP     [func_ai_out_value_help]
   #define YT2_VALUE    func2_AI_out_value
   #define YT2_LRV      func2_AI_out_lower_range_value
   #define YT2_URV      func2_AI_out_upper_range_value
#endif

/* Device type Checking -  these are used by "SIHAST.inc" to control device checking */
#define ENABLE_IDENTCHECK
#define ENABLE_DIAGNOSIS

/* enable save feature in echo profile window */
#define SAVEECHOPROFILE_INC
//#define SHOWTREND_INC

/* Include Files --------------------------------------------------------------*/
/***** Standard includes *****/
#include "bi_codes.h"                      /* Standard EDDL Return Codes */
#include "macros.ddl"                      /* Standard EDDL Macro's */

/***** PDM Standard includes *****/
#include "SIHA.inc"                        /* Standard Hart Includes */
#include "SI_MainMenu.inc"                 /* Standard Menu includes */
#include "SI_FileM.inc"                    /* Standard File Menu */
#include "SI_ViewM.inc"                    /* Standard View Menu */
#include "SI_OptM.inc"                     /* Standard Options Menu */
#include "SI_HlpM.inc"                     /* Standard Help Menu */
#include "SIHAST.inc"                      /* Standard Device type Checking */

#ifdef EDDL_SUPPORT
   #include "SI__Global_02.ddl"               /* Diagnostic support */
#else
   #include "SI__Global_01.ddl"               /* Diagnostic support */
#endif

/***** Product Specific Includes *****/
#include "pvdef.dd"
#include "compatability.inc"
#include "readechoprofile.dd"

/* Devices sub menu */
#include "selftest.dd"                     /* Self Test menu item in Device sub menu */
#include "reset.dd"                        /* Master Reset menu item in Device sub menu */
// #include "simulate_faults.dd"              /* Fault Simulation menu item in Device sub menu */
#include "writelock.dd"                    /* Write lock menu item in Device sub menu */

   #include "simulation.dd"                /* Simulation menu item in Device sub menu */
   #include "quickstart.dd"                /* Quick setup wizard menu item in Device sub menu */
   #include "autotvt.inc"                  /* Auto TVT menu item in Device sub menu */
   #include "tvtshaper120.inc"             /* Manual TVT menu item in Device sub menu */
   #include "maintenance.dd"               /* Maintenance dialogs in Device and View|Status */
   #include "sensortrim.dd"                /* Sensor trim menu item in Device sub menu */
#ifdef EDDL_SUPPORT
#else
#endif

/* View sub menu */
#include "readanalog.dd"                   /* Read Analog Out dialog item in View sub menu */
#include "clearfaults.dd"                  /* Clear Faults dialog item in View sub menu */

   #include "display.dd"                   /* Display window in View sub menu */
#ifdef EDDL_SUPPORT
   #include "trend.inc"
   #include "echoprofile.inc"              /* Echo profile dialog in View sub menu */
   #include "showtrend.inc"
   #include "saveechoprofile.inc"          /* Show Saved Echo profile dialog in View sub menu */
#endif
   #include "diagnostic.dd"                /* Status window item in View sub menu */
   #include "wear.dd"                      /* Wear window item in View sub menu */
   #include "indicators.dd"                /* Peak values window item in View sub menu */


/* Maintenance and Diagnostic information */
#include "SMHA_LR460_DeviceDiagnosis.dd"   /* Extended diagnostic information */


/* Imports --------------------------------------------------------------------*/
#include "LR460_HA_imports.dd"

/* Collections ----------------------------------------------------------------*/

/* Relations ------------------------------------------------------------------*/
#include "LR460_HA_relations.dd"

/* Variable Definitions -------------------------------------------------------*/
#include "LR460_HA_parameters.dd"          /* Auto generated parameters */
/*-----------------------------------------------------------------------------
   Description:: Information for EDD_HelpGen
   Created by:	Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE phys_device_description_local
{
   LABEL [phys_device_description_local_label];
   HELP [phys_device_description_local_help];
   CLASS LOCAL;
   TYPE ASCII(12)
   {
      DEFAULT_VALUE DD_VERSION;
   }
   PRE_EDIT_ACTIONS
   {
      method_preedit_dd_rev
   }
}

/*-----------------------------------------------------------------------------
   Description: Information for EDD_HelpGen
   Created by:  Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE DEVICE_TYPE_Name
{
	LABEL "DEVICE_TYPE_Name";
	TYPE ASCII(40)
	{
		DEFAULT_VALUE DEVICE_TYPE_NAME;
	}

	CLASS LOCAL ;
}

VARIABLE DEVICE_TYPE_Description
{
	LABEL "DEVICE_TYPE_Description";
	TYPE ASCII(256)
	{
		DEFAULT_VALUE DEVICE_TYPE_DESCRIPTION;
	}
	CLASS LOCAL ;
}

VARIABLE DEVICE_TYPE_Manufacturer
{
	LABEL "DEVICE_TYPE Manufacturer";
	TYPE ASCII(40)
	{
		DEFAULT_VALUE DEVICE_TYPE_MANUFACTURER;
	}
	CLASS LOCAL ;
}

VARIABLE DEVICE_TYPE_ContactWebsite
{
	LABEL "DEVICE_TYPE Website";
	TYPE ASCII(40)
	{
		DEFAULT_VALUE DEVICE_TYPE_WEB_SITE;
	}
	CLASS LOCAL ;
}

VARIABLE DEVICE_Order_Number
{
	LABEL	[par_pb_product_code_label];
	HELP	[par_pb_product_code_help];
	CLASS	LOCAL;
	TYPE    ASCII (32)
	{
		DEFAULT_VALUE DEVICE_ORDER_NUMBER;
	}
	HANDLING    READ;
	PURPOSE	    "Device.Type.Ident.OrderNumber";
}

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE phys_device_certification
{
   LABEL    [phys_device_certification_label];
   HELP     [phys_device_certification_help];
   CLASS    LOCAL;
   TYPE     ASCII (32)
   {
      DEFAULT_VALUE "see plate |de|siehe Geraeteschild";
   }
   HANDLING READ;
}

VARIABLE remove_dependencies
{
   LABEL "";
   HELP "";
   CLASS DEVICE;
   TYPE INTEGER;
   HANDLING WRITE;
}

VARIABLE add_dependencies
{
   LABEL "";
   HELP "";
   CLASS DEVICE;
   TYPE INTEGER;
   HANDLING WRITE;
}

/* Command Definitions --------------------------------------------------------*/
#include "LR460_HA_commands.dd"            /* Auto generated commands */
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
COMMAND write_remove_dependencies
{
   NUMBER 251;
   OPERATION WRITE;
   TRANSACTION
   {
      REQUEST
      {
         remove_dependencies
      }
      REPLY
      {
         response_code,device_status,remove_dependencies
      }
   }
   RESPONSE_CODES
   {
      0, SUCCESS,            [no_command_specific_errors];
      2, DATA_ENTRY_ERROR,   [invalid_selection];
      3, DATA_ENTRY_ERROR,   [passed_parameter_too_large];
      4, DATA_ENTRY_ERROR,   [passed_parameter_too_small];
      5, MISC_ERROR,         [too_few_data_bytes_recieved];
      6, MISC_ERROR,         [xmtr_specific_command_error];
      7, MODE_ERROR,         [in_write_protect_mode];
      8, DATA_ENTRY_WARNING, [set_to_nearest_possible_value];
      16,MODE_ERROR,         [access_restricted];
   }
}

COMMAND write_add_dependencies
{
   NUMBER 251;
   OPERATION WRITE;
   TRANSACTION
   {
      REQUEST
      {
         add_dependencies
      }
      REPLY
      {
         response_code,device_status,add_dependencies
      }
   }
   RESPONSE_CODES
   {
      0, SUCCESS,            [no_command_specific_errors];
      2, DATA_ENTRY_ERROR,   [invalid_selection];
      3, DATA_ENTRY_ERROR,   [passed_parameter_too_large];
      4, DATA_ENTRY_ERROR,   [passed_parameter_too_small];
      5, MISC_ERROR,         [too_few_data_bytes_recieved];
      6, MISC_ERROR,         [xmtr_specific_command_error];
      7, MODE_ERROR,         [in_write_protect_mode];
      8, DATA_ENTRY_WARNING, [set_to_nearest_possible_value];
      16,MODE_ERROR,         [access_restricted];
   }
}

/* Menu Definitions -----------------------------------------------------------*/
#include "LR460_HA_menus.dd"               /* Auto generated menu structure */

/*-----------------------------------------------------------------------------
   Description: Main table for Maintenance
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Table_Main_Maintenance
{
   LABEL  [Table_Main_Specialist_label];
   STYLE_TABLE
   ITEMS
   {
      phys_device_description_local (READ_ONLY),
      Tab_s_ident,
      Tab_s_input,
      Tab_s_output,
      Tab_s_certificates,
      Tab_s_diagnosis
   }
}

/*-----------------------------------------------------------------------------
   Description: MENU Bar
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Menu_Main_Specialist
{
   LABEL  [main_menu];
   STYLE_MENU
   ITEMS
   {
      Menu_File,        /* use standard PDM method */
      Menu_S_Device,
      Menu_S_View,
      Menu_S_Options,   /* use standard PDM method */
      Menu_Help         /* use standard PDM method */
   }
}

MENU Menu_Main_Maintenance
{
   LABEL  [main_menu];
   STYLE_MENU
   ITEMS
   {
      Menu_File,        /* use standard PDM method */
      Menu_M_Device,
      Menu_M_View,      /* use standard PDM method */
      Menu_M_Options,   /* use standard PDM method */
      Menu_Help         /* use standard PDM method */
   }
}

/*-----------------------------------------------------------------------------
   Description: Device drop down menu
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Menu_S_Device
{
   LABEL  [menu_Device];
   STYLE_MENU
   ITEMS
   {
      std_CommWay,                 /* use standard PDM method */
      SEPARATOR,
      std_LoadinDevice,            /* use standard PDM method */
      std_LoadinPC,                /* use standard PDM method */
      SEPARATOR,
      #ifdef EDDL_SUPPORT
         setup_wizard,
         method_menu_auto_false_echo_suppression,
         method_menu_tvt_shaper,
         SEPARATOR,
      #else
      #endif
      OfflineDialog_Maintenance_Status,
      method_menu_self_test,
      OnlineDialog_reset,
      configuration_flag_reset,    /* use standard PDM method */
      SEPARATOR,
      dac_trim,                    /* use standard method */
      #ifdef SIMULATE_FAULTS_DD
      OnlineWindow_fault_simulation,
      #endif
      OnlineDialog_write_locking,
      SEPARATOR,
      loop_test,                   /* use standard PDM method */
      SEPARATOR,
      OnlineDialog_hart_comm,      /* use standard PDM method */
      Menu_simulation,
      SEPARATOR,
//      OnlineDialog_sensor_trim    //removed per marketing request. 
   }
}

MENU Menu_M_Device
{
   LABEL  [menu_Device];
   STYLE_MENU
   ITEMS
   {
      std_LoadinDevice,            /* use standard PDM method */
      std_LoadinPC,                /* use standard PDM method */
   }
}

/*-----------------------------------------------------------------------------
   Description: View drop down menu
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Menu_S_View
{
   LABEL  [menu_View];
   STYLE_MENU
   ITEMS
   {
      OnlineWindow_display,
      SEPARATOR,
      #ifdef EDDL_SUPPORT
         method_menu_trend,
         method_menu_echo_profile,
         method_menu_saved_echo,
         SEPARATOR,
      #else
         OnlineWindow_yt,
         SEPARATOR,
      #endif
      OnlineWindow_status,
      OnlineDialog_read_analog,
      OnlineDialog_diagnosis_del,
      OnlineWindow_indicators,
      OnlineWindow_wear,
      SEPARATOR,
      std_Funktionsleiste,       /* use standard PDM method */
      std_Statuszeile,           /* use standard PDM method */
      SEPARATOR,
      std_Update                 /* use standard PDM method */
   }
}

/*-----------------------------------------------------------------------------
   Description: upload/download
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU download_variables
{
   LABEL  [menu_load_to_PC];
   ITEMS
   {
      tag,
      descriptor,
      message,
      date,
      trans1_calibration_type,
      trans1_cal_point_lo,
      trans1_cal_point_hi,
      trans1_level_lo,
      trans1_level_hi,
      DOWNLOADLIST
   }
   PRE_WRITE_ACTIONS
   {
      DEFINITION
      {
         _TRACE("Start Download");
         ReadCommand(read_trans1_calibration);
         ReadCommand(read_func1_AI_out_unit_text);
         ReadCommand(read_func2_AI_out_unit_text);
      }
   }
   POST_WRITE_ACTIONS
   {
      DEFINITION
      {
         _TRACE("Finish Download");
      }
   }
}

MENU upload_variables
{
   LABEL  [menu_load_to_device];
   ITEMS
   {
      tag,
      descriptor,
      message,
      date,
      IF (trans1_calibration_type != 1)
      {
//         trans1_calibration_type,
         trans1_cal_point_lo,
         trans1_cal_point_hi,
         trans1_level_lo,
         trans1_level_hi,
      }
      UPLOADLIST,
   }
   PRE_WRITE_ACTIONS
   {
      method_remove_dependencies
   }
   POST_WRITE_ACTIONS
   {
      method_add_dependencies
   }
}

/* Graphic Elements -----------------------------------------------------------*/

/* Method Definitions ---------------------------------------------------------*/
#include "LR460_HA_methods.dd"             /* methods called from autogenerated files */
/*-----------------------------------------------------------------------------
   Description: PRE_EDIT_ACTIONS for VARIABLE phys_device_description_local
   Created by: Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_preedit_dd_rev
{
   DEFINITION
   {
      phys_device_description_local = DD_VERSION;
      phys_device_description_local.VARIABLE_STATUS = 0;
   }
}

/*-----------------------------------------------------------------------------
   Description: This method is used in multiple locations to display the transfer
                button.
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_set
{
   LABEL    [transfer];
   HELP     [transfer_help];
   DEFINITION
   {
   }
}

METHOD method_remove_dependencies
{
   LABEL [remove_label];
   DEFINITION
   {
     WriteCommand(write_trans1_calibration);
     WriteCommand(write_func1_AI_out_unit_text);
     WriteCommand(write_func2_AI_out_unit_text);
     DELAY_TIME(5);
     _TRACE("remove_dependencies");
     remove_dependencies = 1 ;
     WriteCommand(write_remove_dependencies);
   }
}

METHOD method_add_dependencies
{
   LABEL [add_label];
   DEFINITION
   {
     _TRACE("add_dependencies");
     add_dependencies = 0 ;
     WriteCommand(write_add_dependencies);
   }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
