 /*
$Id: autotvt.inc 1.3 2006/10/16 13:39:04EDT Pathak, Pranjal (Pranjal Pathak) Dev  $
$ProjectName: d:/elect/source/device_descriptions/hart/lr460/pdm/lr460_hart_pdm.pj $   $Locker:  $
*/
#ifndef AUTO_TVT_DD
#define AUTO_TVT_DD
#endif

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
		 Auto TVT dialog for a device that uses auto false echo suppression feature.
       
         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------

       The user calls the method "method_menu_auto_false_echo_suppression" or this
       method can be added to a menu.
       
       The "autotvtopt.dd" file must be created, 
       Use the template with the name "autotvtopt.tpl.dd".
       
   Defines --------------------------------------------------------------------*/
#define AUTO_TVT_OFF   0
#define AUTO_TVT_ON    1
#define AUTO_TVT_LEARN 2

/* Include Files --------------------------------------------------------------*/
#include "autotvtopt.dd"

/* Collections ----------------------------------------------------------------*/

/* Relations (Unit, Array, Refresh) -------------------------------------------*/

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
var_auto_tvt_range_local LIKE VARIABLE AUTO_TVT_RANGE
{
   REDEFINE CLASS LOCAL;
}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU OnlineDialog_auto_false_echo_suppression
{
   LABEL AUTO_TVT_DIALOG_LABEL;
   HELP  AUTO_TVT_DIALOG_HELP; 
   ACCESS ONLINE;
   STYLE_DIALOG
   ITEMS
   {
      AUTO_TVT_MODE (READ_ONLY),
      method_auto_near_tvt_learn,
      method_auto_near_tvt_turn_on,
      method_auto_near_tvt_turn_off,
      var_auto_tvt_range_local,
      method_auto_near_tvt_set_range,
      COLUMNBREAK,
      image_afes_echoprofile
   }
}

#ifdef EDDL_SUPPORT
IMAGE image_afes_echoprofile
{
   PATH AUTO_TVT_IMAGE;
}
#endif

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_menu_auto_false_echo_suppression
{
   LABEL AUTO_TVT_DIALOG_LABEL;
   HELP  AUTO_TVT_DIALOG_HELP; 
   ACCESS ONLINE;
	CLASS  INPUT;   
   DEFINITION
   {  
      long result;

      var_auto_tvt_range_local = AUTO_TVT_RANGE;

      MenuDisplay(OnlineDialog_auto_false_echo_suppression, AUTO_TVT_CLOSE_BUTTON, result);
   }
} 

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_auto_near_tvt_learn
{          
   LABEL AUTO_TVT_LEARN_LABEL;
   HELP  AUTO_TVT_LEARN_HELP; 
   DEFINITION
   {
      AUTO_TVT_READ_COMMAND;
      AUTO_TVT_MODE = AUTO_TVT_LEARN;
      AUTO_TVT_WRITE_COMMAND;
   }
   VALIDITY
      IF (AUTO_TVT_MODE != AUTO_TVT_LEARN)
         {
         TRUE;
         }
      ELSE
         {
         FALSE;
         }
}

METHOD method_auto_near_tvt_turn_on
{          
   LABEL AUTO_TVT_TURN_ON_LABEL;
   HELP  AUTO_TVT_TURN_ON_HELP; 
   DEFINITION
   {
      if (AUTO_TVT_MODE == AUTO_TVT_OFF)
         {
         AUTO_TVT_READ_COMMAND;
         AUTO_TVT_MODE = AUTO_TVT_ON;
         AUTO_TVT_WRITE_COMMAND;
         }
   }
   VALIDITY
      IF (AUTO_TVT_MODE != AUTO_TVT_LEARN)
         {
         TRUE;
         }
      ELSE
         {
         FALSE;
         }
}

METHOD method_auto_near_tvt_turn_off
{          
   LABEL AUTO_TVT_TURN_OFF_LABEL;
   HELP  AUTO_TVT_TURN_OFF_HELP; 
   DEFINITION
   {
      if (AUTO_TVT_MODE == AUTO_TVT_ON)
         {
         AUTO_TVT_READ_COMMAND;
         AUTO_TVT_MODE = AUTO_TVT_OFF;
         AUTO_TVT_WRITE_COMMAND;
         }
   }
   VALIDITY
      IF (AUTO_TVT_MODE != AUTO_TVT_LEARN)
         {
         TRUE;
         }
      ELSE
         {
         FALSE;
         }
}

METHOD method_auto_near_tvt_set_range
{          
   LABEL AUTO_TVT_SET_RANGE_LABEL;
   HELP  AUTO_TVT_SET_RANGE_HELP; 
   DEFINITION
   {
      AUTO_TVT_READ_COMMAND;
      AUTO_TVT_RANGE = var_auto_tvt_range_local;
      AUTO_TVT_WRITE_COMMAND;
      
      /* read it back to make sure it got set properly */
      AUTO_TVT_READ_COMMAND;
      var_auto_tvt_range_local = AUTO_TVT_RANGE;
   }
   VALIDITY
      IF (AUTO_TVT_MODE != AUTO_TVT_LEARN)
         {
         TRUE;
         }
      ELSE
         {
         FALSE;
         }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
