 /*
$Id: showtrend.inc 1.9 2006/10/16 13:39:07EDT Pathak, Pranjal (Pranjal Pathak) Dev  $
$ProjectName: d:/elect/source/device_descriptions/hart/lr460/pdm/lr460_hart_pdm.pj $   $Locker:  $
*/

#ifndef SHOWTREND_INC
#define SHOWTREND_INC
#endif

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
       Library DD File.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------

   Include Files --------------------------------------------------------------*/

/* Defines --------------------------------------------------------------------*/
#define HAVE_SAVED_TRENDS             \
            IF (var_trend_count > 0)  \
               {                      \
               TRUE;                  \
               }                      \
            ELSE                      \
               {                      \
               FALSE;                 \
               }
               
#define MACRO_TREND_LIST_ELEMENTS( index )               \
         IF ( var_trend_count > index )                 \
            {                                            \
               {  index, list_trend[index].TREND_NAME }, \
            }

#define VALUE_INT_TRUE 1
#define VALUE_INT_FALSE 0

#define TREND_MAX_POINTS 1440

/* Collections ----------------------------------------------------------------*/
#ifdef EDDL_SUPPORT
COLLECTION collection_trend_info
{
   MEMBERS
   {
      TREND_NAME,         var_trend_name;
      COMMENT,            var_trend_comment;
      
      DATE_STAMP_START,   var_date_trend_start_save;
      DATE_STAMP_STOP,    var_date_trend_stop_save;

      TREND_DATA,         array_trend_measured_level;             
      
      X_AXIS_POINTS,      var_trend_index_measured_level;
      X_AXIS_INC,         var_trend_frequency;
            
      Y_AXIS_START,       var_trend_lrv;
      Y_AXIS_END,         var_trend_urv;
      Y_AXIS_UNITS,       var_trend_unit;
   }
}
#endif

/* Relations ------------------------------------------------------------------*/
#ifdef EDDL_SUPPORT
LIST list_trend
{
   TYPE    collection_trend_info;
}
#endif

REFRESH REFRESH_LIST_TREND
{
   list_trend
   :
   var_trend_current_item,
   var_trend_count
}


/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Variables in the collection_trend_info collection    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_trend_name
{
   LABEL  [var_trend_name_label];
   CLASS  LOCAL;
   TYPE   ASCII (50); 
}

VARIABLE var_trend_comment
{
   LABEL  [trend_comment_profile_label];
   CLASS  LOCAL;
   STYLE  "MULTILINE 25 2";
   TYPE   ASCII (50); 
}

VARIABLE var_date_trend_start_save
{
   LABEL  [var_date_trend_start_save_label];
   HELP   [var_date_trend_start_save_help];
   CLASS  LOCAL;
   TYPE   DATE_AND_TIME;
   HANDLING READ;   
}

var_date_trend_stop_save LIKE VARIABLE var_date_trend_start_save
{
   REDEFINE LABEL [var_date_trend_stop_save_label];
   REDEFINE HELP  [var_date_trend_stop_save_help];
}

ARRAY array_trend_measured_level
{
   LABEL  [measured_level_array_label];
   TYPE   var_trend_measured_level;
   NUMBER_OF_ELEMENTS TREND_MAX_POINTS;
}

var_trend_measured_level LIKE VARIABLE TREND_LEVEL_VALUE
{
   REDEFINE CLASS LOCAL;
}

VARIABLE var_trend_index_measured_level
{
   CLASS LOCAL;
   TYPE INTEGER (4) 
   {
      DEFAULT_VALUE 0;
      MIN_VALUE     0;
      MAX_VALUE     65535;
   }      
}

VARIABLE var_trend_frequency
{
   CLASS  LOCAL;
   TYPE   UNSIGNED_INTEGER (4)
   {
      DEFAULT_VALUE 1;
      MIN_VALUE 1;
      MAX_VALUE 60;
   }   
   HANDLING
      IF (var_trend_saving == 0)
      {
         READ & WRITE;
      }
      ELSE
      {
         READ;
      }
}

var_trend_lrv LIKE VARIABLE TREND_LEVEL_LRV 
{
}

var_trend_urv LIKE VARIABLE TREND_LEVEL_URV 
{
}

var_trend_unit LIKE VARIABLE TREND_LEVEL_UNITS
{
   REDEFINE CLASS LOCAL;
}

/*-----------------------------------------------------------------------------
   Description: Variables in the collection_trend_info collection    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
   Description:     
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

VARIABLE var_trend_saving
{
   CLASS  LOCAL;
   TYPE   ENUMERATED(1)
   {
      DEFAULT_VALUE VALUE_INT_FALSE;
      {VALUE_INT_TRUE,  "true"},
      {VALUE_INT_FALSE, "false"}
   }
}

var_current_trend_name LIKE VARIABLE var_trend_name
{
   REDEFINE HANDLING READ;
   REDEFINE VALIDITY TRUE;
}

/*
FILE file_trend_saved
{
   MEMBERS
   {
      TREND_DATA,  list_trend;
   }     
}
*/

var_trend_frequency_counter LIKE VARIABLE var_trend_index_measured_level
{
}

VARIABLE var_trend_max_length
{
   LABEL  [trend_max_len_variable_label];
   CLASS  LOCAL;
   TYPE   ENUMERATED (1)
   {
      DEFAULT_VALUE 10;
      { 1,  [ length_04_hours ] },      
      { 10, [ length_4_hours ] },
      { 30, [ length_12_hours ] },      
      { 60, [ length_24_hours ] }
   }   
   CONSTANT_UNIT [h];
   HANDLING READ;
}

VARIABLE var_trend_frequency_local
{
   LABEL  [trend_frequency_variable_label];
   CLASS  LOCAL;
   TYPE   ENUMERATED (1)
   {
      DEFAULT_VALUE 10;
      { 1,  [ frequency_1 ] },      
      { 10, [ frequency_10 ] },
      { 30, [ frequency_30 ] },      
      { 60, [ frequency_60 ] }
   }   
   CONSTANT_UNIT [s];
   POST_EDIT_ACTIONS
   {
      DEFINITION
      {
         var_trend_max_length = var_trend_frequency_local;
      }
   }   
}


/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Variables used to display saved trend   
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_trend_current_index
{
   CLASS LOCAL;
   TYPE INDEX list_trend;
}

VARIABLE var_trend_count
{
   CLASS DYNAMIC;
   TYPE INDEX list_trend
   {
   DEFAULT_VALUE list_trend.COUNT;
   }
}

VARIABLE var_trend_current_item
{
   CLASS  LOCAL;
   TYPE   ENUMERATED
   {
      DEFAULT_VALUE 0;
      MACRO_TREND_LIST_ELEMENTS( 0)
      MACRO_TREND_LIST_ELEMENTS( 1)
      MACRO_TREND_LIST_ELEMENTS( 2)
      MACRO_TREND_LIST_ELEMENTS( 3)
      MACRO_TREND_LIST_ELEMENTS( 4)
      MACRO_TREND_LIST_ELEMENTS( 5)
      MACRO_TREND_LIST_ELEMENTS( 6)
      MACRO_TREND_LIST_ELEMENTS( 7)
      MACRO_TREND_LIST_ELEMENTS( 8)
      MACRO_TREND_LIST_ELEMENTS( 9)
      MACRO_TREND_LIST_ELEMENTS(10)
      MACRO_TREND_LIST_ELEMENTS(11)
      MACRO_TREND_LIST_ELEMENTS(12)
      MACRO_TREND_LIST_ELEMENTS(13)
      MACRO_TREND_LIST_ELEMENTS(14)
      MACRO_TREND_LIST_ELEMENTS(15)
      MACRO_TREND_LIST_ELEMENTS(16)
      MACRO_TREND_LIST_ELEMENTS(17)
      MACRO_TREND_LIST_ELEMENTS(18)
      MACRO_TREND_LIST_ELEMENTS(19)
      MACRO_TREND_LIST_ELEMENTS(20)
      MACRO_TREND_LIST_ELEMENTS(21)
      MACRO_TREND_LIST_ELEMENTS(22)
      MACRO_TREND_LIST_ELEMENTS(23)
      MACRO_TREND_LIST_ELEMENTS(24)
      MACRO_TREND_LIST_ELEMENTS(25)
      MACRO_TREND_LIST_ELEMENTS(26)
      MACRO_TREND_LIST_ELEMENTS(27)
      MACRO_TREND_LIST_ELEMENTS(28)
      MACRO_TREND_LIST_ELEMENTS(29)
      MACRO_TREND_LIST_ELEMENTS(30)
      MACRO_TREND_LIST_ELEMENTS(31)
      MACRO_TREND_LIST_ELEMENTS(32)
      MACRO_TREND_LIST_ELEMENTS(33)
      MACRO_TREND_LIST_ELEMENTS(34)
      MACRO_TREND_LIST_ELEMENTS(35)
      MACRO_TREND_LIST_ELEMENTS(36)
      MACRO_TREND_LIST_ELEMENTS(37)
      MACRO_TREND_LIST_ELEMENTS(38)
      MACRO_TREND_LIST_ELEMENTS(39)
      MACRO_TREND_LIST_ELEMENTS(40)
      MACRO_TREND_LIST_ELEMENTS(41)
      MACRO_TREND_LIST_ELEMENTS(42)
      MACRO_TREND_LIST_ELEMENTS(43)
      MACRO_TREND_LIST_ELEMENTS(44)
      MACRO_TREND_LIST_ELEMENTS(45)
      MACRO_TREND_LIST_ELEMENTS(46)
      MACRO_TREND_LIST_ELEMENTS(47)
      MACRO_TREND_LIST_ELEMENTS(48)
      MACRO_TREND_LIST_ELEMENTS(49)
   }
   VALIDITY HAVE_SAVED_TRENDS;
   POST_EDIT_ACTIONS
   {
      method_get_current_trend_data
   }
}

var_trend_current_comment     LIKE VARIABLE var_trend_comment
{
}

var_trend_current_start_time  LIKE VARIABLE var_date_trend_start_save
{
}

var_trend_current_stop_time   LIKE VARIABLE var_date_trend_stop_save 
{
}

array_saved_trend_points      LIKE ARRAY    array_trend_measured_level    
{
}

var_trend_current_y_units     LIKE VARIABLE var_trend_unit
{
   REDEFINE LABEL "y units";
}

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Menu group for Trend Save Functionality    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU group_save_trend
{
   LABEL  [trend_menu_group_save_label];    
   STYLE_GROUP
   ITEMS
   {  
      var_current_trend_name,
      COLUMNBREAK,
      method_trend_save_start,
      method_trend_save_stop
   }
}

MENU menu_edit_trend                           
{
   LABEL  [trend_menu_save_as_label];
   STYLE_DIALOG
   ITEMS
   {
      var_trend_name            (DISPLAY_VALUE),
      var_trend_comment         (DISPLAY_VALUE),
      var_date_trend_start_save (DISPLAY_VALUE),
      var_trend_frequency_local (DISPLAY_VALUE),
      var_trend_max_length      (DISPLAY_VALUE)
   }
}

/*-----------------------------------------------------------------------------
   Description: Menus for Show Saved Trend Functionality    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU OfflineWindow_saved_trend
{
   LABEL  [trend_method_menu_saved_label];
   ACCESS OFFLINE;
   STYLE_WINDOW
   ITEMS
   {
      page_saved_trend
   }
}

MENU page_saved_trend
{
   LABEL [ trend_method_menu_saved_label ];
   STYLE_PAGE
   ITEMS
   {
      group_saved_trend_start_end,
      graph_saved_trend
   }
}

MENU group_saved_trend_start_end
{
   STYLE_GROUP
   ITEMS
   {  
      var_trend_current_item,
      var_trend_current_comment,
      var_trend_current_start_time,
      var_trend_current_stop_time,
      COLUMNBREAK,
      method_delete_saved_trend_list,
      method_change_saved_trend_comment
   }
}

/* Visual component Definitions -----------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Displays graph area, for Show Saved Trend Functionality   
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#ifdef EDDL_SUPPORT
GRAPH graph_saved_trend
{
   X_AXIS x_axis_saved_trend;
   MEMBERS
   {
      WAVEFORM_SAVED_TREND_1, waveform_saved_trend;
   }
   WIDTH    LARGE;
   HEIGHT   X_LARGE;
   VALIDITY HAVE_SAVED_TRENDS;
}

WAVEFORM waveform_saved_trend
{
   Y_AXIS y_axis_saved_trend;
   TYPE YT
   {
      X_INITIAL        0;
      X_INCREMENT
         IF( var_trend_count > 0 ) 
            { 
            list_trend[var_trend_current_index].X_AXIS_INC; 
            } 
         ELSE 
            { 
            0; 
            }
      
      NUMBER_OF_POINTS 
         IF( var_trend_count > 0 ) 
            { 
            list_trend[var_trend_current_index].X_AXIS_POINTS; 
            } 
         ELSE 
            { 
            0; 
            }
      Y_VALUES
      {
         array_saved_trend_points;
      }
   }
   INIT_ACTIONS
   {
      DEFINITION
      {
         var_trend_current_index = 0;
         method_get_current_trend_data();
      }
   }
}

AXIS y_axis_saved_trend
{
   LABEL   [trend_axis_level_label];
   MIN_VALUE
      IF( var_trend_count > 0 ) 
         { 
         list_trend[var_trend_current_index].Y_AXIS_START; 
         } 
      ELSE 
         { 
         0; 
         }
   MAX_VALUE
      IF( var_trend_count > 0 ) 
         { 
         list_trend[var_trend_current_index].Y_AXIS_END; 
         } 
      ELSE 
         { 
         0; 
         }
   CONSTANT_UNIT 
      IF( var_trend_count > 0 ) 
         { 
         list_trend[var_trend_current_index].Y_AXIS_UNITS; 
         } 
      ELSE 
         { 
         0; 
         }
}

AXIS x_axis_saved_trend
{
   LABEL     [trend_axis_time_label];
   MIN_VALUE 0;
   MAX_VALUE
      IF( var_trend_count > 0 ) 
         { 
         list_trend[var_trend_current_index].X_AXIS_POINTS * list_trend[var_trend_current_index].X_AXIS_INC; 
         } 
      ELSE 
         { 
         0; 
         }
   CONSTANT_UNIT [sec];
}
#endif

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Methods for Trend Save Functionality    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_trend_save_init
{
   DEFINITION
   {
      var_current_trend_name = dictionary_string(not_saving_label);
   }
}

METHOD method_trend_save_start
{
   LABEL  [trend_method_start_label];
   DEFINITION
   {      
      long result;
#ifdef EDDL_SUPPORT
      DD_STRING name;
      DD_STRING theComment;
      int index;


      if (var_trend_saving)
         {
         return;
         }

      if (var_trend_count < 50)
         {         
         var_trend_name    = "";
         var_trend_comment = "";
         var_date_trend_start_save = GetCurrentDateAndTime();
         ListInsert(list_trend, var_trend_count, collection_trend_info);
         var_trend_count = list_trend.COUNT;
         
         MenuDisplay(menu_edit_trend, dictionary_string(confirm_buttons_label), result);
         
         if (result == 0)
            {
            var_date_trend_start_save = GetCurrentDateAndTime();
            
            var_trend_name = strtrim(var_trend_name);
            if (strlen(var_trend_name) <= 0)
               {
               var_trend_name = var_date_trend_start_save;
               }
                     
            var_trend_frequency            = var_trend_frequency_local;
            var_trend_index_measured_level = 0;
            var_trend_frequency_counter    = 0;
            var_trend_saving               = 1;

            list_trend[var_trend_count - 1].DATE_STAMP_START   = var_date_trend_start_save;
            list_trend[var_trend_count - 1].TREND_NAME         = var_trend_name;
            list_trend[var_trend_count - 1].COMMENT            = var_trend_comment;
            list_trend[var_trend_count - 1].Y_AXIS_UNITS       = TREND_LEVEL_UNITS;
            list_trend[var_trend_count - 1].Y_AXIS_START       = TREND_LEVEL_LRV;
            list_trend[var_trend_count - 1].Y_AXIS_END         = TREND_LEVEL_URV;
            list_trend[var_trend_count - 1].X_AXIS_INC         = var_trend_frequency;
            
            var_current_trend_name = var_trend_name;
         
            }
         else
            {
            var_current_trend_name = dictionary_string(not_saving_label);
            ListDeleteElementAt(list_trend, var_trend_count - 1);                        
            var_trend_count = list_trend.COUNT;
            }
         }
#endif
   }
}

METHOD method_trend_save_save_data
{
   DEFINITION
   {
      if( var_trend_saving == 1 )         
         {
         var_trend_frequency_counter++;
         if (var_trend_frequency_counter >= var_trend_frequency)
            {
            if (var_trend_index_measured_level < TREND_MAX_POINTS)
               {
               list_trend[var_trend_count - 1].TREND_DATA[var_trend_index_measured_level] = TREND_LEVEL_VALUE;
               var_trend_index_measured_level = var_trend_index_measured_level + 1;
               } 
            else // end of save
               {
               method_trend_save_stop();
               }
            var_trend_frequency_counter = 0;
            }
         }
   }
}

METHOD method_trend_save_stop
{
   LABEL  [trend_method_stop_label];
   DEFINITION
   {      
      if (var_trend_saving)
      {
         list_trend[var_trend_count - 1].DATE_STAMP_STOP = GetCurrentDateAndTime();
         list_trend[var_trend_count - 1].X_AXIS_POINTS   = var_trend_index_measured_level;

         var_current_trend_name = dictionary_string(not_saving_label);
         var_trend_saving = 0;
      }
      _TRACE("##### " + itoa(var_trend_count) + " #####");
   }
}

/*-----------------------------------------------------------------------------
   Description: Methods for Show Saved Trend Functionality    
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_menu_saved_trend
{
   LABEL  [method_menu_saved_trend_label];
   ACCESS OFFLINE;
   DEFINITION
   {  
      long result;
      MenuDisplay(OfflineWindow_saved_trend, [ok_label], result);
   }
   VALIDITY HAVE_SAVED_TRENDS;
} 

METHOD method_delete_saved_trend_list
{
   LABEL  [trend_method_list_delete_label];
   DEFINITION
   {
      int result;
      
      if (var_trend_count == 0)
         {
         return;
         }
      result = SELECT_FROM_LIST( dictionary_string(Delete_message), dictionary_string(confirm_buttons));
      if (!result)
         {
         ListDeleteElementAt(list_trend, var_trend_current_index);
         var_trend_count = list_trend.COUNT;
         var_trend_current_index = var_trend_current_index - 1;  
         }
   }
}

METHOD method_change_saved_trend_comment
{
   LABEL  [trend_method_save_label];
   DEFINITION
   {
      int result;
      
      result = SELECT_FROM_LIST(dictionary_string(Save_comment_message), dictionary_string(confirm_buttons));
      if ( result )
         {
         var_trend_current_comment = list_trend[var_trend_current_index].COMMENT;
         }
      else
         {
         list_trend[var_trend_current_index].COMMENT = var_trend_current_comment;      
         }
   }
   VALIDITY HAVE_SAVED_TRENDS;   
}

METHOD method_get_current_trend_data
{
   DEFINITION
   {
      int i;
      
      for (i = 0; i < list_trend[var_trend_current_index].X_AXIS_POINTS; i++)
      {
         array_saved_trend_points[i] = list_trend[var_trend_current_index].TREND_DATA[i];
      }
   
      var_trend_current_start_time  = list_trend[var_trend_current_index].DATE_STAMP_START;
      var_trend_current_stop_time   = list_trend[var_trend_current_index].DATE_STAMP_STOP;
      var_trend_current_comment     = list_trend[var_trend_current_index].COMMENT;
   }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/

